//****************************************************************************
//	aisa23w.pas
//
//	aISA-P23
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/27
//
//****************************************************************************

unit aisa23w;

interface

uses
	Windows;

{ Errors }

const
	AISA23_SUCCESS							= 0;	 { ُȂ }
	AISA23_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA23_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA23_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA23_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA23_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA23_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA23_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA23_PORT_0	= 0;
	AISA23_PORT_1	= 1;
  AISA23_PORT_2	= 2;
	AISA23_PORT_3	= 3;


{ Miscellaneous }

const
	AISA23_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA23_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA23_DLL_NAME = 'aisa23.dll';		{ DLL }

function Aisa23wDllOpen: Boolean;			{ DLL [h }
function Aisa23wDllClose: Boolean;		{ DLL A[h }


const
	AISA23_SLOT_AUTO = $ffff;

{ aISA-P23 DLL,Driver̃o[Wԍ擾 }
function Aisa23wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P23̎gp錾 }
function Aisa23wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P23̎gpJ }
function Aisa23wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA23_MAX_MEM	=	 9;
		AISA23_MAX_IO		= 20;
		AISA23_MAX_IRQ	=	 7;
		AISA23_MAX_DMA	=	 7;

type
		TAISA23RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA23_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA23_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA23_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA23_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA23_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA23_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA23_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA23_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA23_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA23RESOURCE = ^TAISA23RESOURCE;

{ \[X擾 }
function Aisa23wGetResource(wLogSlot: Word;  pResInfo: PAISA23RESOURCE): Boolean;

{ Cӂ̃|[gփf[^o }
function Aisa23wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;

{ aISA-P23̃G[R[h }
function Aisa23wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa23GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa23Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa23Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa23GetResource = function(wLogSlot: WORD; res: PAISA23RESOURCE):	BOOL; stdcall;
	TAisa23OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa23GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa23wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa23GetVersion: TAisa23GetVersion;
	pAisa23Create: TAisa23Create;
	pAisa23Close: TAisa23Close;
	pAisa23GetResource: TAisa23GetResource;
	pAisa23OutPort: TAisa23OutPort;
	pAisa23GetLastError: TAisa23GetLastError;


//****************************************************************************
// @\			aisa23.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa23wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA23_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa23wGetDllExportFunc = False then
  begin
       Aisa23wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa23.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa23wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P23 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa23wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa23GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P23̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa23wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa23Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P23̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa23wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa23Close(wLogSlot);
end;

//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa23wGetResource(wLogSlot: Word;  pResInfo: PAISA23RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa23GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa23wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa23OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P23̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa23wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA23_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa23GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa23wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa23GetVersion ̃AhX擾
	pAisa23GetVersion := GetProcAddress(hDLL, 'Aisa23GetVersion');
	if @pAisa23GetVersion = nil then Exit;

	// Aisa23Create ̃AhX擾
	pAisa23Create := GetProcAddress(hDLL, 'Aisa23Create');
	if @pAisa23Create = nil then Exit;

	// Aisa23Close ̃AhX擾
	pAisa23Close := GetProcAddress(hDLL, 'Aisa23Close');
	if @pAisa23Close = nil then Exit;

	// Aisa23GetResource ̃AhX擾
	pAisa23GetResource := GetProcAddress(hDLL, 'Aisa23GetResource');
	if @pAisa23GetResource = nil then Exit;

	// Aisa23OutPort ̃AhX擾
	pAisa23OutPort := GetProcAddress(hDLL, 'Aisa23OutPort');
	if @pAisa23OutPort = nil then Exit;

	// Aisa23GetLastError ̃AhX擾
	pAisa23GetLastError := GetProcAddress(hDLL, 'Aisa23GetLastError');
	if @pAisa23GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

