Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa23w.bas
'*
'* aISA-P23
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/10
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA23_DLL_NAME = "aisa23.dll"  ' DLLt@C
Global Const AISA23_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa23.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa23wDllOpen() As Boolean

    Aisa23wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA23_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa23wGetDllExportFunc() = False Then
        Aisa23wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa23wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa23.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa23wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa23wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa23wDllClose = True
        Exit Function
    End If
    
    Aisa23wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-P23 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True       --- 
'*          False      --- s
'*****************************************************************************
Function Aisa23wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa23wGetVersion = 0
        Exit Function
    End If
    
    If Aisa23GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa23wGetVersion = True
    Else
        Aisa23wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P23̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa23wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa23wCreate = False
        Exit Function
    End If
    
    If Aisa23Create(pwLogSlot) <> 0 Then
        Aisa23wCreate = True
    Else
        Aisa23wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P23̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa23wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa23wClose = False
        Exit Function
    End If
    
    If Aisa23Close(wLogSlot) <> 0 Then
        Aisa23wClose = True
    Else
        Aisa23wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa23wGetResource(wLogSlot As Integer, pResInfo As AISA23RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa23wGetResource = False
        Exit Function
    End If
    
    If Aisa23GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa23wGetResource = True
    Else
        Aisa23wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa23wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa23wOutPort = False
        Exit Function
    End If
    
    If Aisa23OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa23wOutPort = True
    Else
        Aisa23wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-P23̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa23wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa23wGetLastError = AISA23_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa23wGetLastError = Aisa23GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa23wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa23wGetDllExportFunc = False
    
    ' Aisa23GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa23Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa23Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23Close")
    If pFunc = 0 Then Exit Function

    ' Aisa23GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa23OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa23GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa23GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa23wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
