/*****************************************************************************
 *	aisa23s.c
 *
 *	aISA-P23
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#define	STRICT
#include	<windows.h>
#include	<tchar.h>
#include	"aisa23w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP23[] = _T("aISA-P23");
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  OutValue;
	AISA23RESOURCE ri;				// \[X

//-----------------	 aisa23.dll ̎gp錾 --------------------------------
	if (Aisa23wDllOpen() == FALSE) {
		ErrorMessage(AISA23_SLOT_AUTO);
		return 1;			// aisa23.dll ̃[hɎs܂
	}

//--------------------	o[Wԍ\	----------------------------------
	// aISA-P23 DLL,Driver̃o[Wԍ擾
	if (Aisa23wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(AISA23_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("GetVersion\n") _T("DLL Version: %08lxh\n")
							_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);

//-----------------------  aISA-P23̎gp錾	 ---------------------------

	wLogSlot = AISA23_SLOT_AUTO;			// gp̃foCXT܂B
	bResult = Aisa23wCreate( &wLogSlot );
				// wLogSlot -- ꍇA̎̃foCXi[܂B
	if (bResult == FALSE) {
		ErrorMessage(AISA23_SLOT_AUTO);		// foCX܂B
		return 1;
	}
	wsprintf(szbuf, _T("aISA-P23 Created\n\n") _T("LogSlot: %2d\n"), wLogSlot);
	ResultMessage(szbuf);

//------------------------------  \[X擾  -------------------------
	if (Aisa23wGetResource(wLogSlot, &ri) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Board Name: %s\n") _T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n") ,
					szP23, ri.dwIOPortLength[0], ri.dwIOPortBase[0],
					ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1 );
	ResultMessage(szbuf);

//------------------   Port0 ɔCӂ̃f[^o  ----------------------------
	OutValue = (BYTE)0xAA;					// o̓f[^ AAh

	if (Aisa23wOutPort(wLogSlot, AISA23_PORT_0, OutValue) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Port0փf[^o\n")
					_T("Port0 Out Data: %02xh"), OutValue);
	ResultMessage(szbuf);

//-------------------  aISA-P23̎gpJ	 -------------------------------
	if (Aisa23wClose(wLogSlot) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aISA-P23 Closed"));

//----------------------  aisa23.dll ̎gpJ  ----------------------------
	if (Aisa23wDllClose() == FALSE) {
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"),
										szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa23.dll ̃A[hɎs܂B
	}
	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa23wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AISA23_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %23lxh"), GetLastError());
			break;

		case AISA23_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P23 error\n\n")
							_T("Error code: %23lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
